import _ from 'lodash';

//

var script = {
    name: "Column",
    props: {
        column: {
            type: Object,
            default: function () {
                return {};
            }
        },
        query: {
            type: Object,
            default: function () {
                return {};
            }
        }
    },
    data: function () {
        return {};
    },
    methods: {
        sort: function sort() {
            this.$emit("update-sort", this.column);
        }
    },
    components: {
    },
    computed: {
        isSort: function isSort() {
            if (this.query.sort.name == null) {
                return false;
            }

            return this.query.sort.name === this.column.name;
        },

        isSortableColumn: function isSortableColumn() {
            if (!_.has(this.column,'sort')) {
                return false;
            } else {
                return this.column.sort;
            }
        }
    }
};

/* script */
            var __vue_script__ = script;
            
/* template */
var __vue_render__ = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c(
    "th",
    _vm._g(
      {
        staticClass: "text-center",
        class: { "vbt-sort-cursor": _vm.isSortableColumn }
      },
      _vm.isSortableColumn
        ? {
            click: function() {
              return _vm.sort()
            }
          }
        : {}
    ),
    [
      _vm._t("column", [_vm._v(_vm._s(_vm.column.label))], {
        column: _vm.column
      }),
      _vm._v(" "),
      _vm.isSortableColumn
        ? [
            !_vm.isSort
              ? [
                  _c(
                    "div",
                    { staticClass: "float-right" },
                    [
                      _vm._t("no-sort-icon", [
                        _vm._v("\n                    🠥🠧\n                ")
                      ])
                    ],
                    2
                  )
                ]
              : [
                  _vm.query.sort.order === "asc"
                    ? [
                        _c(
                          "div",
                          { staticClass: "float-right" },
                          [
                            _vm._t("sort-asc-icon", [
                              _vm._v(
                                "\n                        🠥\n                    "
                              )
                            ])
                          ],
                          2
                        )
                      ]
                    : _vm.query.sort.order === "desc"
                      ? [
                          _vm._t("sort-desc-icon", [
                            _c("div", { staticClass: "float-right" }, [
                              _vm._v("🠧")
                            ])
                          ])
                        ]
                      : [
                          _c(
                            "div",
                            { staticClass: "float-right" },
                            [
                              _vm._t("no-sort-icon", [
                                _vm._v(
                                  "\n                        🠥🠧\n                    "
                                )
                              ])
                            ],
                            2
                          )
                        ]
                ]
          ]
        : _vm._e()
    ],
    2
  )
};
var __vue_staticRenderFns__ = [];
__vue_render__._withStripped = true;

  /* style */
  var __vue_inject_styles__ = function (inject) {
    if (!inject) { return }
    inject("data-v-1ec66fdf_0", { source: "\n.vbt-sort-cursor[data-v-1ec66fdf] {\n    cursor: pointer;\n}\n", map: {"version":3,"sources":["/home/ruby/repos/vue-bootstrap4-table/src/components/Column.vue"],"names":[],"mappings":";AA6FA;IACA,gBAAA;CACA","file":"Column.vue","sourcesContent":["<template>\n<th v-on=\"isSortableColumn ? { click: () => sort() } : {}\" class=\"text-center\" v-bind:class=\"{'vbt-sort-cursor':isSortableColumn}\">\n    <slot name=\"column\" :column=\"column\">{{column.label}}</slot>\n\n    <template v-if=\"isSortableColumn\">\n        <template v-if=\"!isSort\">\n            <div class=\"float-right\">\n                <slot name=\"no-sort-icon\">\n                    &#x1F825;&#x1F827;\n                </slot>\n            </div>\n        </template>\n\n        <template v-else>\n            <template v-if=\"query.sort.order==='asc'\">\n                <div class=\"float-right\">\n                    <slot name=\"sort-asc-icon\">\n                        &#x1F825;\n                    </slot>\n                </div>\n            </template>\n\n            <template v-else-if=\"query.sort.order==='desc'\">\n                <slot name=\"sort-desc-icon\">\n                    <div class=\"float-right\">&#x1F827;</div>\n                </slot>\n            </template>\n\n            <template v-else>\n                <div class=\"float-right\">\n                    <slot name=\"no-sort-icon\">\n                        &#x1F825;&#x1F827;\n                    </slot>\n                </div>\n            </template>\n        </template>\n    </template>\n\n</th>\n</template>\n\n<script>\nimport _ from \"lodash\";\n\nexport default {\n    name: \"Column\",\n    props: {\n        column: {\n            type: Object,\n            default: function () {\n                return {};\n            }\n        },\n        query: {\n            type: Object,\n            default: function () {\n                return {};\n            }\n        }\n    },\n    data: function () {\n        return {};\n    },\n    methods: {\n        sort() {\n            this.$emit(\"update-sort\", this.column);\n        }\n    },\n    components: {\n    },\n    computed: {\n        isSort() {\n            if (this.query.sort.name == null) {\n                return false;\n            }\n\n            return this.query.sort.name === this.column.name;\n        },\n\n        isSortableColumn() {\n            if (!_.has(this.column,'sort')) {\n                return false;\n            } else {\n                return this.column.sort;\n            }\n        }\n    }\n};\n</script>\n\n// TODO icon color\n\n<style scoped>\n.vbt-sort-cursor {\n    cursor: pointer;\n}\n</style>\n"]}, media: undefined });

  };
  /* scoped */
  var __vue_scope_id__ = "data-v-1ec66fdf";
  /* module identifier */
  var __vue_module_identifier__ = undefined;
  /* functional template */
  var __vue_is_functional_template__ = false;
  /* component normalizer */
  function __vue_normalize__(
    template, style, script$$1,
    scope, functional, moduleIdentifier,
    createInjector, createInjectorSSR
  ) {
    var component = (typeof script$$1 === 'function' ? script$$1.options : script$$1) || {};

    // For security concerns, we use only base name in production mode.
    component.__file = "/home/ruby/repos/vue-bootstrap4-table/src/components/Column.vue";

    if (!component.render) {
      component.render = template.render;
      component.staticRenderFns = template.staticRenderFns;
      component._compiled = true;

      if (functional) { component.functional = true; }
    }

    component._scopeId = scope;

    {
      var hook;
      if (style) {
        hook = function(context) {
          style.call(this, createInjector(context));
        };
      }

      if (hook !== undefined) {
        if (component.functional) {
          // register for functional component in vue file
          var originalRender = component.render;
          component.render = function renderWithStyleInjection(h, context) {
            hook.call(context);
            return originalRender(h, context)
          };
        } else {
          // inject component registration as beforeCreate hook
          var existing = component.beforeCreate;
          component.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
      }
    }

    return component
  }
  /* style inject */
  function __vue_create_injector__() {
    var head = document.head || document.getElementsByTagName('head')[0];
    var styles = __vue_create_injector__.styles || (__vue_create_injector__.styles = {});
    var isOldIE =
      typeof navigator !== 'undefined' &&
      /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());

    return function addStyle(id, css) {
      if (document.querySelector('style[data-vue-ssr-id~="' + id + '"]')) { return } // SSR styles are present.

      var group = isOldIE ? css.media || 'default' : id;
      var style = styles[group] || (styles[group] = { ids: [], parts: [], element: undefined });

      if (!style.ids.includes(id)) {
        var code = css.source;
        var index = style.ids.length;

        style.ids.push(id);

        if (isOldIE) {
          style.element = style.element || document.querySelector('style[data-group=' + group + ']');
        }

        if (!style.element) {
          var el = style.element = document.createElement('style');
          el.type = 'text/css';

          if (css.media) { el.setAttribute('media', css.media); }
          if (isOldIE) {
            el.setAttribute('data-group', group);
            el.setAttribute('data-next-index', '0');
          }

          head.appendChild(el);
        }

        if (isOldIE) {
          index = parseInt(style.element.getAttribute('data-next-index'));
          style.element.setAttribute('data-next-index', index + 1);
        }

        if (style.element.styleSheet) {
          style.parts.push(code);
          style.element.styleSheet.cssText = style.parts
            .filter(Boolean)
            .join('\n');
        } else {
          var textNode = document.createTextNode(code);
          var nodes = style.element.childNodes;
          if (nodes[index]) { style.element.removeChild(nodes[index]); }
          if (nodes.length) { style.element.insertBefore(textNode, nodes[index]); }
          else { style.element.appendChild(textNode); }
        }
      }
    }
  }
  /* style inject SSR */
  

  
  var Column = __vue_normalize__(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    __vue_create_injector__,
    undefined
  );

//

var script$1 = {
    name: 'Header',
    props: {
        columns: {
            type: Array,
            default: function() {
                return [];
            }
        },
        query: {
            type:Object,
            default:function () {
                return {};
            }
        }
    },
    data: function() {
        return {

        }
    },
    methods: {

    },
    components: {
        Column: Column
    },
    computed: {

    }
};

/* script */
            var __vue_script__$1 = script$1;
            
/* template */
var __vue_render__$1 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c(
    "thead",
    [
      _vm._t(
        "columns",
        [
          _c(
            "tr",
            _vm._l(_vm.columns, function(column, key, index) {
              return _c("Column", {
                key: index,
                attrs: { column: column, query: _vm.query },
                on: {
                  "update-sort": function(payload) {
                    return _vm.$emit("update-sort", payload)
                  }
                }
              })
            }),
            1
          )
        ],
        { columns: _vm.columns }
      )
    ],
    2
  )
};
var __vue_staticRenderFns__$1 = [];
__vue_render__$1._withStripped = true;

  /* style */
  var __vue_inject_styles__$1 = undefined;
  /* scoped */
  var __vue_scope_id__$1 = undefined;
  /* module identifier */
  var __vue_module_identifier__$1 = undefined;
  /* functional template */
  var __vue_is_functional_template__$1 = false;
  /* component normalizer */
  function __vue_normalize__$1(
    template, style, script,
    scope, functional, moduleIdentifier,
    createInjector, createInjectorSSR
  ) {
    var component = (typeof script === 'function' ? script.options : script) || {};

    // For security concerns, we use only base name in production mode.
    component.__file = "/home/ruby/repos/vue-bootstrap4-table/src/components/Header.vue";

    if (!component.render) {
      component.render = template.render;
      component.staticRenderFns = template.staticRenderFns;
      component._compiled = true;

      if (functional) { component.functional = true; }
    }

    component._scopeId = scope;

    return component
  }
  /* style inject */
  
  /* style inject SSR */
  

  
  var Header = __vue_normalize__$1(
    { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
    __vue_inject_styles__$1,
    __vue_script__$1,
    __vue_scope_id__$1,
    __vue_is_functional_template__$1,
    __vue_module_identifier__$1,
    undefined,
    undefined
  );

//

var script$2 = {
    name: 'Row',
    props: {
        row: {
            type: Object,
            default: function() {
                return {

                };
            }
        },
        columns: {
            type: Array,
            default: function() {
                return [];
            }
        }
    },
    data: function() {
        return {

        }
    },
    mounted: function mounted() {

    },
    methods: {
        getValueFromRow: function getValueFromRow(row, name) {
            return _.get(row, name);
        }
    }
};

/* script */
            var __vue_script__$2 = script$2;
            
/* template */
var __vue_render__$2 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c(
    "tr",
    _vm._l(_vm.columns, function(column, key, hindex) {
      return _c(
        "td",
        { key: hindex, staticClass: "text-center" },
        [
          _vm._t(
            "cell",
            [
              _vm._v(
                "\n            " +
                  _vm._s(_vm.getValueFromRow(_vm.row, column.name)) +
                  "\n        "
              )
            ],
            {
              row: _vm.row,
              column: column,
              cell_value: _vm.getValueFromRow(_vm.row, column.name)
            }
          )
        ],
        2
      )
    }),
    0
  )
};
var __vue_staticRenderFns__$2 = [];
__vue_render__$2._withStripped = true;

  /* style */
  var __vue_inject_styles__$2 = undefined;
  /* scoped */
  var __vue_scope_id__$2 = undefined;
  /* module identifier */
  var __vue_module_identifier__$2 = undefined;
  /* functional template */
  var __vue_is_functional_template__$2 = false;
  /* component normalizer */
  function __vue_normalize__$2(
    template, style, script,
    scope, functional, moduleIdentifier,
    createInjector, createInjectorSSR
  ) {
    var component = (typeof script === 'function' ? script.options : script) || {};

    // For security concerns, we use only base name in production mode.
    component.__file = "/home/ruby/repos/vue-bootstrap4-table/src/components/Row.vue";

    if (!component.render) {
      component.render = template.render;
      component.staticRenderFns = template.staticRenderFns;
      component._compiled = true;

      if (functional) { component.functional = true; }
    }

    component._scopeId = scope;

    return component
  }
  /* style inject */
  
  /* style inject SSR */
  

  
  var Row = __vue_normalize__$2(
    { render: __vue_render__$2, staticRenderFns: __vue_staticRenderFns__$2 },
    __vue_inject_styles__$2,
    __vue_script__$2,
    __vue_scope_id__$2,
    __vue_is_functional_template__$2,
    __vue_module_identifier__$2,
    undefined,
    undefined
  );

//

var script$3 = {
    name: "Simple",
    props: {
        column: {
            type: Object,
            default: function() {
                return {};
            }
        },
    },
    data: function() {
        return {};
    },
    methods: {
        clearFilter: function clearFilter() {
            $(this.$refs.simple_filter_input).val("");
            this.$emit('clear-filter',this.column);
        },
        // TODO - configurable debouncing
        updateFilter: _.debounce(function(event) {
            this.$emit('update-filter', {
                "event": event,
                "column": this.column
            });
        }, 60),
    },
    components: {
    },
    computed: {}
};

/* script */
            var __vue_script__$3 = script$3;
            
/* template */
var __vue_render__$3 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "input-group" }, [
    _c("input", {
      ref: "simple_filter_input",
      staticClass: "form-control",
      attrs: { type: "text", placeholder: _vm.column.filter.placeholder },
      on: {
        keyup: function($event) {
          $event.stopPropagation();
          _vm.updateFilter($event);
        }
      }
    }),
    _vm._v(" "),
    _c(
      "div",
      { staticClass: "input-group-append", on: { click: _vm.clearFilter } },
      [
        _c(
          "span",
          { staticClass: "input-group-text" },
          [
            _vm._t("clear-simple-filter-icon", [
              _vm._v("\n                ⓧ\n            ")
            ])
          ],
          2
        )
      ]
    )
  ])
};
var __vue_staticRenderFns__$3 = [];
__vue_render__$3._withStripped = true;

  /* style */
  var __vue_inject_styles__$3 = function (inject) {
    if (!inject) { return }
    inject("data-v-304059ca_0", { source: "\n.input-group-append[data-v-304059ca] {\n    cursor: pointer;\n}\n", map: {"version":3,"sources":["/home/ruby/repos/vue-bootstrap4-table/src/components/Filters/Simple.vue"],"names":[],"mappings":";AAkDA;IACA,gBAAA;CACA","file":"Simple.vue","sourcesContent":["<template>\n    <div class=\"input-group\">\n        <input ref=\"simple_filter_input\" type=\"text\" class=\"form-control\" :placeholder=\"column.filter.placeholder\" @keyup.stop=\"updateFilter($event)\">\n        <div class=\"input-group-append\" @click=\"clearFilter\">\n            <span class=\"input-group-text\">\n                <slot name=\"clear-simple-filter-icon\">\n                    &#x24E7;\n                </slot>\n            </span>\n        </div>\n    </div>\n    <!-- <input type=\"search\" class=\"form-control\" :placeholder=\"column.filter.placeholder\" @keyup.stop=\"updateFilter($event)\"> -->\n</template>\n\n<script>\n    import _ from \"lodash\";\n\n    export default {\n        name: \"Simple\",\n        props: {\n            column: {\n                type: Object,\n                default: function() {\n                    return {};\n                }\n            },\n        },\n        data: function() {\n            return {};\n        },\n        methods: {\n            clearFilter() {\n                $(this.$refs.simple_filter_input).val(\"\");\n                this.$emit('clear-filter',this.column);\n            },\n            // TODO - configurable debouncing\n            updateFilter: _.debounce(function(event) {\n                this.$emit('update-filter', {\n                    \"event\": event,\n                    \"column\": this.column\n                });\n            }, 60),\n        },\n        components: {\n        },\n        computed: {}\n    };\n</script>\n\n<style scoped>\n    .input-group-append {\n        cursor: pointer;\n    }\n</style>\n"]}, media: undefined });

  };
  /* scoped */
  var __vue_scope_id__$3 = "data-v-304059ca";
  /* module identifier */
  var __vue_module_identifier__$3 = undefined;
  /* functional template */
  var __vue_is_functional_template__$3 = false;
  /* component normalizer */
  function __vue_normalize__$3(
    template, style, script,
    scope, functional, moduleIdentifier,
    createInjector, createInjectorSSR
  ) {
    var component = (typeof script === 'function' ? script.options : script) || {};

    // For security concerns, we use only base name in production mode.
    component.__file = "/home/ruby/repos/vue-bootstrap4-table/src/components/Filters/Simple.vue";

    if (!component.render) {
      component.render = template.render;
      component.staticRenderFns = template.staticRenderFns;
      component._compiled = true;

      if (functional) { component.functional = true; }
    }

    component._scopeId = scope;

    {
      var hook;
      if (style) {
        hook = function(context) {
          style.call(this, createInjector(context));
        };
      }

      if (hook !== undefined) {
        if (component.functional) {
          // register for functional component in vue file
          var originalRender = component.render;
          component.render = function renderWithStyleInjection(h, context) {
            hook.call(context);
            return originalRender(h, context)
          };
        } else {
          // inject component registration as beforeCreate hook
          var existing = component.beforeCreate;
          component.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
      }
    }

    return component
  }
  /* style inject */
  function __vue_create_injector__$1() {
    var head = document.head || document.getElementsByTagName('head')[0];
    var styles = __vue_create_injector__$1.styles || (__vue_create_injector__$1.styles = {});
    var isOldIE =
      typeof navigator !== 'undefined' &&
      /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());

    return function addStyle(id, css) {
      if (document.querySelector('style[data-vue-ssr-id~="' + id + '"]')) { return } // SSR styles are present.

      var group = isOldIE ? css.media || 'default' : id;
      var style = styles[group] || (styles[group] = { ids: [], parts: [], element: undefined });

      if (!style.ids.includes(id)) {
        var code = css.source;
        var index = style.ids.length;

        style.ids.push(id);

        if (isOldIE) {
          style.element = style.element || document.querySelector('style[data-group=' + group + ']');
        }

        if (!style.element) {
          var el = style.element = document.createElement('style');
          el.type = 'text/css';

          if (css.media) { el.setAttribute('media', css.media); }
          if (isOldIE) {
            el.setAttribute('data-group', group);
            el.setAttribute('data-next-index', '0');
          }

          head.appendChild(el);
        }

        if (isOldIE) {
          index = parseInt(style.element.getAttribute('data-next-index'));
          style.element.setAttribute('data-next-index', index + 1);
        }

        if (style.element.styleSheet) {
          style.parts.push(code);
          style.element.styleSheet.cssText = style.parts
            .filter(Boolean)
            .join('\n');
        } else {
          var textNode = document.createTextNode(code);
          var nodes = style.element.childNodes;
          if (nodes[index]) { style.element.removeChild(nodes[index]); }
          if (nodes.length) { style.element.insertBefore(textNode, nodes[index]); }
          else { style.element.appendChild(textNode); }
        }
      }
    }
  }
  /* style inject SSR */
  

  
  var Simple = __vue_normalize__$3(
    { render: __vue_render__$3, staticRenderFns: __vue_staticRenderFns__$3 },
    __vue_inject_styles__$3,
    __vue_script__$3,
    __vue_scope_id__$3,
    __vue_is_functional_template__$3,
    __vue_module_identifier__$3,
    __vue_create_injector__$1,
    undefined
  );

//

var script$4 = {
    name: 'Pagination',
    props: {
        page: {
            type: [String, Number],
            required: true
        },
        per_page: {
            type: [String, Number],
            required: true
        },
        total: {
            type: [String, Number],
            required: true
        },
        pagiantion_limit: {
            type: [String, Number],
            default: 7
        }
    },
    data: function() {
        return {
            start: (this.page + 0),
            end: 0
        }
    },
    mounted: function mounted() {
        this.end = (this.page + (this.paginationLimit - 1));
    },
    methods: {
        pageHandler: function pageHandler(index) {
            this.$emit('update:page', index);
        }

    },
    components: {
    },
    computed: {
        totalPages: function totalPages() {
            return Math.ceil(this.total / this.per_page);
        },
        range: function range() {
            return _.range(this.start, (this.end + 1));
        },
        showRightDot: function showRightDot() {
            // return this.
            return !(this.totalPages - this.end <= 0);
        },
        showLeftDot: function showLeftDot() {
            return !(_.includes(this.range, 1));
        },
        paginationLimit: function paginationLimit() {
            if (this.totalPages < this.pagiantion_limit) {
                return this.totalPages;
            } else {
                return this.pagiantion_limit;
            }
        },
        isEmpty: function isEmpty() {
            return this.total == 0;
        }

    },
    watch: {
        page: function page(newVal, oldVal) {
            if (newVal == this.totalPages) {
                this.start = newVal - (this.paginationLimit - 1);
                this.end = newVal;
            } else if (newVal == 1) {
                this.start = newVal;
                this.end = newVal + (this.paginationLimit - 1);
            } else {
                if (newVal > oldVal) {
                    if (this.end - newVal < 1) {
                        this.start += 1;
                        this.end += 1;
                    }
                } else {
                    if (this.start - newVal >= 0) {
                        this.start -= 1;
                        this.end -= 1;
                    }
                }

            }
        },
        total: function total(newVal, oldVal) {
            if (this.page == this.totalPages) {
                this.start = this.page - (this.paginationLimit - 1);
                this.end = this.page;
            } else if (this.page == 1) {
                this.start = this.page;
                this.end = this.page + (this.paginationLimit - 1);
            }
        },
        totalPages: function totalPages(newVal, oldVal) {
            if (this.page == this.totalPages) {
                this.start = this.page - (this.paginationLimit - 1);
                this.end = this.page;
            } else if (this.page == 1) {
                this.start = this.page;
                this.end = this.page + (this.paginationLimit - 1);
            }
        }
    }
};

/* script */
            var __vue_script__$4 = script$4;
            
/* template */
var __vue_render__$4 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", [
    _c("nav", { attrs: { "aria-label": "Page navigation example" } }, [
      _c(
        "ul",
        { staticClass: "pagination" },
        [
          _vm._m(0),
          _vm._v(" "),
          !_vm.isEmpty
            ? [
                _vm.showLeftDot
                  ? _c(
                      "li",
                      {
                        staticClass: "page-item",
                        on: {
                          click: function($event) {
                            _vm.pageHandler(1);
                          }
                        }
                      },
                      [
                        _c(
                          "a",
                          { staticClass: "page-link", attrs: { href: "#" } },
                          [_vm._v(" 1 ")]
                        )
                      ]
                    )
                  : _vm._e(),
                _vm._v(" "),
                _vm.showLeftDot
                  ? _c("li", { staticClass: "page-item disabled" }, [
                      _c(
                        "a",
                        { staticClass: "page-link", attrs: { href: "#" } },
                        [_vm._v("...")]
                      )
                    ])
                  : _vm._e(),
                _vm._v(" "),
                _vm._l(_vm.range, function(index) {
                  return _c(
                    "li",
                    {
                      key: index,
                      staticClass: "page-item",
                      class: { active: index == _vm.page },
                      on: {
                        click: function($event) {
                          _vm.pageHandler(index);
                        }
                      }
                    },
                    [
                      _c(
                        "a",
                        { staticClass: "page-link", attrs: { href: "#" } },
                        [_vm._v(_vm._s(index))]
                      )
                    ]
                  )
                }),
                _vm._v(" "),
                _vm.showRightDot
                  ? _c("li", { staticClass: "page-item disabled" }, [
                      _c(
                        "a",
                        { staticClass: "page-link", attrs: { href: "#" } },
                        [_vm._v("...")]
                      )
                    ])
                  : _vm._e(),
                _vm._v(" "),
                _vm.showRightDot
                  ? _c(
                      "li",
                      {
                        staticClass: "page-item",
                        on: {
                          click: function($event) {
                            _vm.pageHandler(_vm.totalPages);
                          }
                        }
                      },
                      [
                        _c(
                          "a",
                          { staticClass: "page-link", attrs: { href: "#" } },
                          [_vm._v(" " + _vm._s(_vm.totalPages) + " ")]
                        )
                      ]
                    )
                  : _vm._e()
              ]
            : [_vm._m(1)],
          _vm._v(" "),
          _vm._m(2)
        ],
        2
      )
    ])
  ])
};
var __vue_staticRenderFns__$4 = [
  function() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c("li", { staticClass: "page-item" }, [
      _c(
        "a",
        {
          staticClass: "page-link",
          attrs: { href: "#", "aria-label": "Previous" }
        },
        [
          _c("span", { attrs: { "aria-hidden": "true" } }, [_vm._v("«")]),
          _vm._v(" "),
          _c("span", { staticClass: "sr-only" }, [_vm._v("Previous")])
        ]
      )
    ])
  },
  function() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c("li", { staticClass: "page-item disabled" }, [
      _c("a", { staticClass: "page-link", attrs: { href: "#" } }, [
        _vm._v("...")
      ])
    ])
  },
  function() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c("li", { staticClass: "page-item" }, [
      _c(
        "a",
        {
          staticClass: "page-link",
          attrs: { href: "#", "aria-label": "Next" }
        },
        [
          _c("span", { attrs: { "aria-hidden": "true" } }, [_vm._v("»")]),
          _vm._v(" "),
          _c("span", { staticClass: "sr-only" }, [_vm._v("Next")])
        ]
      )
    ])
  }
];
__vue_render__$4._withStripped = true;

  /* style */
  var __vue_inject_styles__$4 = function (inject) {
    if (!inject) { return }
    inject("data-v-dabc75ec_0", { source: "\nul.pagination[data-v-dabc75ec] {\n    margin-bottom: 0;\n}\n", map: {"version":3,"sources":["/home/ruby/repos/vue-bootstrap4-table/src/components/Pagination.vue"],"names":[],"mappings":";AA2JA;IACA,iBAAA;CACA","file":"Pagination.vue","sourcesContent":["<template>\n    <div>\n        <nav aria-label=\"Page navigation example\">\n            <ul class=\"pagination\">\n                <li class=\"page-item\">\n                    <a class=\"page-link\" href=\"#\" aria-label=\"Previous\">\n                        <span aria-hidden=\"true\">&laquo;</span>\n                        <span class=\"sr-only\">Previous</span>\n                    </a>\n                </li>\n                <template v-if=\"!isEmpty\">\n                    <li class=\"page-item\" v-if=\"showLeftDot\" @click=\"pageHandler(1)\">\n                        <a class=\"page-link\" href=\"#\"> 1 </a>\n                    </li>\n                    <li class=\"page-item disabled\" v-if=\"showLeftDot\">\n                        <a class=\"page-link\" href=\"#\">...</a>\n                    </li>\n                    <li class=\"page-item\" v-for=\"index in range\" :key=\"index\" v-bind:class=\"{ active:  (index == page)}\" @click=\"pageHandler(index)\">\n                        <a class=\"page-link\" href=\"#\">{{index}}</a>\n                    </li>\n                    <li class=\"page-item disabled\" v-if=\"showRightDot\">\n                        <a class=\"page-link\" href=\"#\">...</a>\n                    </li>\n                    <li class=\"page-item\" v-if=\"showRightDot\" @click=\"pageHandler(totalPages)\">\n                        <a class=\"page-link\" href=\"#\"> {{totalPages}} </a>\n                    </li>\n                </template>\n                <template v-else>\n                    <li class=\"page-item disabled\">\n                        <a class=\"page-link\" href=\"#\">...</a>\n                    </li>\n                </template>\n                <li class=\"page-item\">\n                    <a class=\"page-link\" href=\"#\" aria-label=\"Next\">\n                        <span aria-hidden=\"true\">&raquo;</span>\n                        <span class=\"sr-only\">Next</span>\n                    </a>\n                </li>\n            </ul>\n        </nav>\n    </div>\n</template>\n\n<script>\n    import _ from 'lodash';\n\n    export default {\n        name: 'Pagination',\n        props: {\n            page: {\n                type: [String, Number],\n                required: true\n            },\n            per_page: {\n                type: [String, Number],\n                required: true\n            },\n            total: {\n                type: [String, Number],\n                required: true\n            },\n            pagiantion_limit: {\n                type: [String, Number],\n                default: 7\n            }\n        },\n        data: function() {\n            return {\n                start: (this.page + 0),\n                end: 0\n            }\n        },\n        mounted() {\n            this.end = (this.page + (this.paginationLimit - 1));\n        },\n        methods: {\n            pageHandler(index) {\n                this.$emit('update:page', index);\n            }\n\n        },\n        components: {\n        },\n        computed: {\n            totalPages() {\n                return Math.ceil(this.total / this.per_page);\n            },\n            range() {\n                return _.range(this.start, (this.end + 1));\n            },\n            showRightDot() {\n                // return this.\n                return !(this.totalPages - this.end <= 0);\n            },\n            showLeftDot() {\n                return !(_.includes(this.range, 1));\n            },\n            paginationLimit() {\n                if (this.totalPages < this.pagiantion_limit) {\n                    return this.totalPages;\n                } else {\n                    return this.pagiantion_limit;\n                }\n            },\n            isEmpty() {\n                return this.total == 0;\n            }\n\n        },\n        watch: {\n            page(newVal, oldVal) {\n                if (newVal == this.totalPages) {\n                    this.start = newVal - (this.paginationLimit - 1);\n                    this.end = newVal;\n                } else if (newVal == 1) {\n                    this.start = newVal;\n                    this.end = newVal + (this.paginationLimit - 1);\n                } else {\n                    if (newVal > oldVal) {\n                        if (this.end - newVal < 1) {\n                            this.start += 1;\n                            this.end += 1;\n                        }\n                    } else {\n                        if (this.start - newVal >= 0) {\n                            this.start -= 1;\n                            this.end -= 1;\n                        }\n                    }\n\n                }\n            },\n            total(newVal, oldVal) {\n                if (this.page == this.totalPages) {\n                    this.start = this.page - (this.paginationLimit - 1);\n                    this.end = this.page;\n                } else if (this.page == 1) {\n                    this.start = this.page;\n                    this.end = this.page + (this.paginationLimit - 1);\n                }\n            },\n            totalPages(newVal, oldVal) {\n                if (this.page == this.totalPages) {\n                    this.start = this.page - (this.paginationLimit - 1);\n                    this.end = this.page;\n                } else if (this.page == 1) {\n                    this.start = this.page;\n                    this.end = this.page + (this.paginationLimit - 1);\n                }\n            }\n        }\n    }\n</script>\n\n<style scoped>\n    ul.pagination {\n        margin-bottom: 0;\n    }\n</style>\n"]}, media: undefined });

  };
  /* scoped */
  var __vue_scope_id__$4 = "data-v-dabc75ec";
  /* module identifier */
  var __vue_module_identifier__$4 = undefined;
  /* functional template */
  var __vue_is_functional_template__$4 = false;
  /* component normalizer */
  function __vue_normalize__$4(
    template, style, script,
    scope, functional, moduleIdentifier,
    createInjector, createInjectorSSR
  ) {
    var component = (typeof script === 'function' ? script.options : script) || {};

    // For security concerns, we use only base name in production mode.
    component.__file = "/home/ruby/repos/vue-bootstrap4-table/src/components/Pagination.vue";

    if (!component.render) {
      component.render = template.render;
      component.staticRenderFns = template.staticRenderFns;
      component._compiled = true;

      if (functional) { component.functional = true; }
    }

    component._scopeId = scope;

    {
      var hook;
      if (style) {
        hook = function(context) {
          style.call(this, createInjector(context));
        };
      }

      if (hook !== undefined) {
        if (component.functional) {
          // register for functional component in vue file
          var originalRender = component.render;
          component.render = function renderWithStyleInjection(h, context) {
            hook.call(context);
            return originalRender(h, context)
          };
        } else {
          // inject component registration as beforeCreate hook
          var existing = component.beforeCreate;
          component.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
      }
    }

    return component
  }
  /* style inject */
  function __vue_create_injector__$2() {
    var head = document.head || document.getElementsByTagName('head')[0];
    var styles = __vue_create_injector__$2.styles || (__vue_create_injector__$2.styles = {});
    var isOldIE =
      typeof navigator !== 'undefined' &&
      /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());

    return function addStyle(id, css) {
      if (document.querySelector('style[data-vue-ssr-id~="' + id + '"]')) { return } // SSR styles are present.

      var group = isOldIE ? css.media || 'default' : id;
      var style = styles[group] || (styles[group] = { ids: [], parts: [], element: undefined });

      if (!style.ids.includes(id)) {
        var code = css.source;
        var index = style.ids.length;

        style.ids.push(id);

        if (isOldIE) {
          style.element = style.element || document.querySelector('style[data-group=' + group + ']');
        }

        if (!style.element) {
          var el = style.element = document.createElement('style');
          el.type = 'text/css';

          if (css.media) { el.setAttribute('media', css.media); }
          if (isOldIE) {
            el.setAttribute('data-group', group);
            el.setAttribute('data-next-index', '0');
          }

          head.appendChild(el);
        }

        if (isOldIE) {
          index = parseInt(style.element.getAttribute('data-next-index'));
          style.element.setAttribute('data-next-index', index + 1);
        }

        if (style.element.styleSheet) {
          style.parts.push(code);
          style.element.styleSheet.cssText = style.parts
            .filter(Boolean)
            .join('\n');
        } else {
          var textNode = document.createTextNode(code);
          var nodes = style.element.childNodes;
          if (nodes[index]) { style.element.removeChild(nodes[index]); }
          if (nodes.length) { style.element.insertBefore(textNode, nodes[index]); }
          else { style.element.appendChild(textNode); }
        }
      }
    }
  }
  /* style inject SSR */
  

  
  var Pagination = __vue_normalize__$4(
    { render: __vue_render__$4, staticRenderFns: __vue_staticRenderFns__$4 },
    __vue_inject_styles__$4,
    __vue_script__$4,
    __vue_scope_id__$4,
    __vue_is_functional_template__$4,
    __vue_module_identifier__$4,
    __vue_create_injector__$2,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//

var script$5 = {
    name: 'PaginationInfo',
    props: {
        currentPageRowsLength: {
            type: Number,
            default: 0
        },
        filteredRowsLength: {
            type: Number,
            default: 0
        },
        originalRowsLength: {
            type: Number,
            default: 0
        }
    },
    data: function () {
        return {

        }
    },
    mounted: function mounted() {

    },
    methods: {

    }
};

/* script */
            var __vue_script__$5 = script$5;
            
/* template */
var __vue_render__$5 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c(
    "div",
    { staticClass: "text-right justify-content-center" },
    [
      _vm.currentPageRowsLength != 0
        ? [
            _vm._v(
              "\n        From 1 to " +
                _vm._s(_vm.currentPageRowsLength) +
                " of " +
                _vm._s(_vm.filteredRowsLength) +
                " entries\n    "
            )
          ]
        : [_vm._v("\n        No results found\n    ")],
      _vm._v(" "),
      [
        _vm._v(
          "\n         (" +
            _vm._s(_vm.originalRowsLength) +
            " total records)\n    "
        )
      ]
    ],
    2
  )
};
var __vue_staticRenderFns__$5 = [];
__vue_render__$5._withStripped = true;

  /* style */
  var __vue_inject_styles__$5 = undefined;
  /* scoped */
  var __vue_scope_id__$5 = undefined;
  /* module identifier */
  var __vue_module_identifier__$5 = undefined;
  /* functional template */
  var __vue_is_functional_template__$5 = false;
  /* component normalizer */
  function __vue_normalize__$5(
    template, style, script,
    scope, functional, moduleIdentifier,
    createInjector, createInjectorSSR
  ) {
    var component = (typeof script === 'function' ? script.options : script) || {};

    // For security concerns, we use only base name in production mode.
    component.__file = "/home/ruby/repos/vue-bootstrap4-table/src/components/PaginationInfo.vue";

    if (!component.render) {
      component.render = template.render;
      component.staticRenderFns = template.staticRenderFns;
      component._compiled = true;

      if (functional) { component.functional = true; }
    }

    component._scopeId = scope;

    return component
  }
  /* style inject */
  
  /* style inject SSR */
  

  
  var PaginationInfo = __vue_normalize__$5(
    { render: __vue_render__$5, staticRenderFns: __vue_staticRenderFns__$5 },
    __vue_inject_styles__$5,
    __vue_script__$5,
    __vue_scope_id__$5,
    __vue_is_functional_template__$5,
    __vue_module_identifier__$5,
    undefined,
    undefined
  );

//

var script$6 = {
    name: "VueBootstrap4Table",
    props: {
        data: {
            type: Object,
            required: true
        },
        config: {
            type: Object,
            default: function() {
                return {};
            }
        }
    },
    data: function() {
        return {
            vbt_data: {
                rows: [],
                columns: []
            },
            query: {
                sort: {
                    name: null,
                    order: "asc"
                },
                filters: []
            },
            page: 1,
            per_page: 3,
            original_rows: [],
            pagiantion_limit: 5,
            temp_filtered_results: [],
            pagination: true
        };
    },
    mounted: function mounted() {
        this.vbt_data = _.cloneDeep(this.data);
        this.original_rows = _.cloneDeep(this.vbt_data.rows);
        this.initConfig();
        this.filter();
        this.paginateFilter();
    },
    components: {
        Header: Header,
        Row: Row,
        Simple: Simple,
        Pagination: Pagination,
        PaginationInfo: PaginationInfo
    },
    methods: {
        initConfig: function initConfig() {
            if (_.isEmpty(this.config)) {
                return;
            }

            if (this.config.pagination && this.config.pagination == true) {
                this.pagiantion_limit = this.config.num_of_visible_page;
                this.per_page = this.config.per_page;
            } else {
                this.pagination = false;
            }
        },

        hasFilter: function hasFilter(column) {
            return _.has(column, "filter.type");
        },

        clearFilter: function clearFilter(column) {
            var filter_index = this.getFilterIndex(column);
            if (filter_index !== -1) {
                this.query.filters.splice(filter_index, 1);
            }
        },

        getFilterIndex: function getFilterIndex(column) {
            return _.findIndex(this.query.filters, {
                name: column.name
            });

            // return (filter_index == -1) ? null : this.query.filters[filter_index];
        },

        updateSort: function updateSort(column) {
            if (this.query.sort.name == column.name) {
                this.query.sort.order =
                    this.query.sort.order == "asc" ? "desc" : "asc";
            } else {
                this.query.sort.name = column.name;
                this.query.sort.order = "desc";
            }

            this.refresh();
        },
        updateFilter: function updateFilter(payload) {
            var event = payload.event;
            var column = payload.column;
            var filter_index = _.findIndex(this.query.filters, {
                name: column.name
            });
            if (filter_index == -1) {
                if (event.target.value !== "") {
                    this.query.filters.push({
                        type: column.filter.type,
                        name: column.name,
                        text: event.target.value
                    });
                }
            } else {
                if (event.target.value === "") {
                    this.query.filters.splice(filter_index, 1);
                } else {
                    this.query.filters[filter_index].text = event.target.value;
                }
            }
        },

        sort: function sort() {
            // TODO- try multipl column sort

            if (this.query.sort.name == null) {
                this.paginateFilter();
                return;
            }

            this.temp_filtered_results = _.orderBy(
                this.temp_filtered_results, [this.query.sort.name], [this.query.sort.order]
            );

            this.paginateFilter();
        },

        filter: function filter() {
            var self = this;

            var res = _.filter(this.original_rows, function(row) {
                var flag = true;
                _.forEach(self.query.filters, function(filter, key) {
                    if (filter.text === "") {
                        flag = true;
                        return false;
                    }

                    if (filter.type === "simple") {
                        if (self.simpleFilter(_.get(row, filter.name), filter.text)) {
                            flag = true;
                        } else {
                            flag = false;
                            return false;
                        }
                    }
                });

                return flag;
            });
            this.temp_filtered_results = res;
            this.sort();
            this.page = 1;
        },

        simpleFilter: function simpleFilter(value, filter_text) {
            if (typeof value !== "string") {
                value = value.toString();
            }

            // TODO - configurable lowercase conversion
            return value.toLowerCase().indexOf(filter_text) > -1;
        },

        refresh: function refresh() {
            this.sort();
        },

        paginateFilter: function paginateFilter() {
            var start = (this.page - 1) * this.per_page;
            var end = start + this.per_page;
            this.vbt_data.rows = this.temp_filtered_results.slice(start, end);
        }
    },
    computed: {
        rowCount: function rowCount() {
            return this.temp_filtered_results.length;
        }
    },
    watch: {
        "query.filters": {
            handler: function(after, before) {
                this.filter();
            },
            deep: true
        },
        page: {
            handler: function(newVal, oldVal) {
                this.paginateFilter();
            }
        },
        per_page: {
            handler: function(newVal, oldVal) {
                this.paginateFilter();
            }
        },
        data: {
            handler: function(newVal, oldVal) {
                this.vbt_data = _.cloneDeep(newVal);
                this.original_rows = _.cloneDeep(this.vbt_data.rows);
                this.filter();
            },
            deep: true
        },
        config: {
            handler: function(newVal, oldVal) {
                this.initConfig();
            },
            deep: true
        }
    }
};

/* script */
            var __vue_script__$6 = script$6;
            
/* template */
var __vue_render__$6 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", { staticClass: "container-fluid" }, [
    _c("div", { staticClass: "card" }, [
      _c("div", { staticClass: "card-header text-center" }, [
        _vm._v("Bootsrap 4 advanced table")
      ]),
      _vm._v(" "),
      _c("div", { staticClass: "card-body" }, [
        _c("div", { staticClass: "table-responsive" }, [
          _c(
            "table",
            { staticClass: "table table-striped table-bordered" },
            [
              _c("Header", {
                attrs: { columns: _vm.vbt_data.columns, query: _vm.query },
                on: { "update-sort": _vm.updateSort }
              }),
              _vm._v(" "),
              _c(
                "tbody",
                [
                  _c(
                    "tr",
                    { staticClass: "table-active" },
                    _vm._l(_vm.vbt_data.columns, function(column, key, index) {
                      return _c(
                        "td",
                        { key: index },
                        [
                          _vm.hasFilter(column)
                            ? _c("Simple", {
                                attrs: { column: column },
                                on: {
                                  "update-filter": _vm.updateFilter,
                                  "clear-filter": _vm.clearFilter
                                }
                              })
                            : _vm._e()
                        ],
                        1
                      )
                    }),
                    0
                  ),
                  _vm._v(" "),
                  _vm._l(_vm.vbt_data.rows, function(row, key, index) {
                    return _c("Row", {
                      key: index,
                      attrs: { row: row, columns: _vm.vbt_data.columns }
                    })
                  })
                ],
                2
              )
            ],
            1
          )
        ])
      ]),
      _vm._v(" "),
      _c("div", { staticClass: "card-footer" }, [
        _c("div", { staticClass: "row" }, [
          _c(
            "div",
            { staticClass: "col-md-6" },
            [
              _c("Pagination", {
                attrs: {
                  page: _vm.page,
                  per_page: _vm.per_page,
                  total: _vm.rowCount,
                  pagiantion_limit: _vm.pagiantion_limit
                },
                on: {
                  "update:page": function($event) {
                    _vm.page = $event;
                  }
                }
              })
            ],
            1
          ),
          _vm._v(" "),
          _c(
            "div",
            { staticClass: "col-md-6" },
            [
              _c("PaginationInfo", {
                attrs: {
                  "current-page-rows-length": _vm.vbt_data.rows.length,
                  "filtered-rows-length": _vm.rowCount,
                  "original-rows-length": _vm.data.rows.length
                }
              })
            ],
            1
          )
        ])
      ])
    ])
  ])
};
var __vue_staticRenderFns__$6 = [];
__vue_render__$6._withStripped = true;

  /* style */
  var __vue_inject_styles__$6 = undefined;
  /* scoped */
  var __vue_scope_id__$6 = undefined;
  /* module identifier */
  var __vue_module_identifier__$6 = undefined;
  /* functional template */
  var __vue_is_functional_template__$6 = false;
  /* component normalizer */
  function __vue_normalize__$6(
    template, style, script,
    scope, functional, moduleIdentifier,
    createInjector, createInjectorSSR
  ) {
    var component = (typeof script === 'function' ? script.options : script) || {};

    // For security concerns, we use only base name in production mode.
    component.__file = "/home/ruby/repos/vue-bootstrap4-table/src/components/VueBootstrap4Table.vue";

    if (!component.render) {
      component.render = template.render;
      component.staticRenderFns = template.staticRenderFns;
      component._compiled = true;

      if (functional) { component.functional = true; }
    }

    component._scopeId = scope;

    return component
  }
  /* style inject */
  
  /* style inject SSR */
  

  
  var component = __vue_normalize__$6(
    { render: __vue_render__$6, staticRenderFns: __vue_staticRenderFns__$6 },
    __vue_inject_styles__$6,
    __vue_script__$6,
    __vue_scope_id__$6,
    __vue_is_functional_template__$6,
    __vue_module_identifier__$6,
    undefined,
    undefined
  );

// Import vue component

// Declare install function executed by Vue.use()
function install(Vue) {
    if (install.installed) { return; }
    install.installed = true;
    Vue.component('VueBootstrap4Table', component);
}

// Create module definition for Vue.use()
var plugin = {
    install: install,
};

// Auto-install when vue is found (eg. in browser via <script> tag)
var GlobalVue = null;
if (typeof window !== 'undefined') {
    GlobalVue = window.Vue;
} else if (typeof global !== 'undefined') {
    GlobalVue = global.Vue;
}
if (GlobalVue) {
    GlobalVue.use(plugin);
}

export default component;
export { install };
